﻿using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.TaskScheduler.Helper;

public class TimerHelper : IDisposable
{
    public static TimerHelper Start(string name, ILogger logger)
    {
        return new TimerHelper(name, logger);
    }

    private readonly string name;
    private readonly ILogger logger;
    private readonly Stopwatch timer;

    private TimerHelper(string name, ILogger logger)
    {
        this.name = name;
        this.logger = logger;
        this.timer = Stopwatch.StartNew();
    }

    public void Dispose()
    {
        timer.Stop();
        if(timer.ElapsedMilliseconds > 1000)
        {
            logger.LogWarning("{0} cost {1} secs", name, timer.ElapsedMilliseconds / 1000);
        }
    }
}
