﻿using Dapper;
using EVCB_OCPP.Domain;
using EVCB_OCPP.Domain.ConnectionFactory;
using EVCB_OCPP.TaskScheduler.Helper;
using Microsoft.Data.SqlClient;
using Microsoft.Extensions.Logging;
using Quartz;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.TaskScheduler.Jobs
{
    [DisallowConcurrentExecution]
    public class DeleteServerMessageJob : IJob
    {
        public DeleteServerMessageJob(
            ILogger<DeleteServerMessageJob> logger, 
            ISqlConnectionFactory<MainDBContext> mainDBConnectionFactory)
        {
            this.logger = logger;
            this.mainDBConnectionFactory = mainDBConnectionFactory;
        }

        private readonly ILogger<DeleteServerMessageJob> logger;
        private readonly ISqlConnectionFactory<MainDBContext> mainDBConnectionFactory;

        public async Task Execute(IJobExecutionContext context)
        {

            logger.LogDebug(this.ToString() + " :Start........");
            int counter = 0;

            while (counter < 5)
            {
                counter++;
                using (var dbConn = await mainDBConnectionFactory.CreateAsync())
                {
                    string sqlstring = "DELETE Top(10000) From ServerMessage WHERE ReceivedOn != '1991-01-01'";
                    await dbConn.ExecuteAsync(sqlstring);
                }
            }

            logger.LogDebug(this.ToString() + " :Finished........");
        }
    }
}
