﻿using Microsoft.AspNetCore.Builder;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace EVCB_OCPP.TaskScheduler.Services
{
    public class TestService : IHostedService
    {
        private readonly IServiceProvider serviceProvider;
        private WebApplication app;

        public TestService(IServiceProvider serviceProvider) {
            this.serviceProvider = serviceProvider;

            var appBuilder = WebApplication.CreateBuilder();
            app = appBuilder.Build();
            app.MapGet("/", () => "");
            app.Urls.Add("http://*:80");
        }

        public Task StartAsync(CancellationToken cancellationToken)
        {
            serviceProvider.GetService<DatabaseService>().GetCallParterAPICustomers();
            return app.StartAsync();
        }

        public Task StopAsync(CancellationToken cancellationToken)
        {
            return app.StopAsync();
        }
    }
}
